#! /bin/sh

> bench.errors

for X
do
	for D in bench%gawk bench%ingres bench%postgres 
	do
		echo >&2
		echo Testing $D with $X tuples in 5 relations >&2
		echo "creating :" >&2

		(	echo "delete from customer;";
			echo "delete from supplier;";
			echo "delete from stock;";
			echo "delete from orders;";
			echo "delete from deliver;";
			) | gsqld $D >>bench.errors

		awk '
		BEGIN {

			for (x=0;x<'$X';x++) {
				printf "insert into customer (id, name)\n";
				printf "values (%d,\"customer %d\");\n", x,x;

				printf "insert into supplier (id, name)\n";
				printf "values (%d,\"supplier %d\");\n", x,x;

				printf "insert into stock (id, name, supplier)\n";
				printf "values (%d,\"stock %d\",%d);\n",
					x,x,int(rand()*'$X');
				}
			printf "\n";
			} ' | time gsqld $D >>bench.errors

		echo "part one :" >&2
		awk '
		BEGIN { 
			for (x=0;x<100;x++)
				print int(rand()*'$X') ,int(rand()*'$X') ,int(rand()*'$X')
			}' |

		awk '
		{	printf "insert into deliver ( article,customer,quant )\n";
			printf "values ( %d, %d, %d );\n", $1, $2, $3;

			printf "update customer set saldo = saldo + %d where id = %d;\n",
				$3, $2;
			printf "update stock set inventory = inventory + %d where id = %d;\n",
				$3, $1;
			}' | time gsqld $D >>bench.errors

		echo "part two :" >&2

		gsql $D 'select id,supplier,inventory from stock where inventory < 0' 2>>bench.errors |
		awk '
		{	printf "insert into orders ( article, supplier, quant )\n";
			printf "values ( %d, %d, %d );\n", $1, $2, -$3;

			printf "update supplier set saldo = saldo + %d where id = %d;\n",
				-$3, $2;
			}' | time gsqld $D >>bench.errors

	done 2>&1 | gawk '
	$3 !~ "elapsed" && $1 !~ "inputs" {
		if ($0 ~ ":$")
			printf "%s ", $0;
		else	printf "%s\n",$0;
		}
	/elapsed/ {	
		sub("elapsed","",$3);
		print $3;
		}
		' | tee bench.out.$X
done
