/* ----------------------------------------------------------------------------
 * gSqlTk.C
 */

extern "C" {
	#include "string.h"
	/* Avoid missmatch */
	#define Cursor X11Cursor
	#include "tk.h"
	#undef  Cursor
	}

#include "mystring.h"
#include "tw_types.h"
#include "SqlManager.h"

extern "C" {
	int GSQL_Init(Tcl_Interp *interp);

	int GSQL_Cmd(ClientData clientData, Tcl_Interp *interp,
		int argc, char **argv);

	int GSQL_Backend(SqlParser *sql);
	}

SqlManager GSQL_Manager;

/* ------------------------------------------------------------------------- */

Tcl_DString GSQL_results;

int GSQL_Backend(SqlParser *sql)
{	Text	*res;
	int	i;
	char	*row;

	res = GSQL_Manager.sql_getresult();
	if (res) {
		Tcl_DStringStartSublist(&GSQL_results);
		for (i=0; i<res->nlines;i++)
			Tcl_DStringAppendElement(&GSQL_results,res->lines[i]);
		Tcl_DStringEndSublist(&GSQL_results);
		Tcl_DStringStartSublist(&GSQL_results);
		while ((row = sql->sql_getrow()))
			Tcl_DStringAppendElement(&GSQL_results,row);
		Tcl_DStringEndSublist(&GSQL_results);
		}
	return(1);
	}

int GSQL_Cmd(ClientData clientData, Tcl_Interp *interp, int argc, char **argv)
{	char *cmd;

	if (argc < 2) {
		Tcl_AppendResult(interp, argv[0], ": missing command name.", 0);
		return TCL_ERROR;
		}

	cmd= strdup(argv[1]);
	argc--; ++argv;
	while (--argc) {
		cmd=strrepcat(cmd," ");
		cmd=strrepcat(cmd,*++argv);
		}
	cmd=strrepcat(cmd,";");

	Tcl_DStringInit(&GSQL_results);
	Tcl_DStringStartSublist(&GSQL_results);
	Tcl_DStringAppendElement(&GSQL_results,cmd);
	Tcl_DStringEndSublist(&GSQL_results);

	GSQL_Manager.sql_backend = GSQL_Backend;
	GSQL_Manager.sql_new(cmd);

	Tcl_DStringResult(interp, &GSQL_results);

	return(TCL_OK);
	}

int GSQL_Init(Tcl_Interp *interp)
{	Tcl_CreateCommand(interp, "gsql", GSQL_Cmd, 0, 0);
	return(TCL_OK);
	}
